spandsp: v22bis_rx.c File Reference

spandsp 0.0.6

Macros | Functions
v22bis_rx.c File Reference
`#include <inttypes.h>`
`#include <string.h>`
`#include <stdio.h>`
`#include <stdlib.h>`
`#include "floating_fudge.h"`
`#include "spandsp/telephony.h"`
`#include "spandsp/logging.h"`
`#include "spandsp/complex.h"`
`#include "spandsp/vector_float.h"`
`#include "spandsp/complex_vector_float.h"`
`#include "spandsp/vector_int.h"`
`#include "spandsp/complex_vector_int.h"`
`#include "spandsp/async.h"`
`#include "spandsp/power_meter.h"`
`#include "spandsp/arctan2.h"`
`#include "spandsp/dds.h"`
`#include "spandsp/complex_filters.h"`
`#include "spandsp/v29rx.h"`
`#include "spandsp/v22bis.h"`
`#include "spandsp/private/logging.h"`
`#include "spandsp/private/v22bis.h"`
`#include "v22bis_rx_1200_floating_rrc.h"`
`#include "v22bis_rx_2400_floating_rrc.h"`

## Macros
#define | FP_SCALE(x) (x)
#define | ms_to_symbols(t) (((t)*600)/1000)
#define | EQUALIZER_DELTA 0.25f
#define | PULSESHAPER_COEFF_SETS 12

## Functions
float | v22bis_rx_carrier_frequency (v22bis_state_t *s)
float | v22bis_rx_symbol_timing_correction (v22bis_state_t *s)
float | v22bis_rx_signal_power (v22bis_state_t *s)
void | v22bis_rx_signal_cutoff (v22bis_state_t *s, float cutoff)
void | v22bis_report_status_change (v22bis_state_t *s, int status)
int | v22bis_rx_equalizer_state (v22bis_state_t *s, complexf_t **coeffs)
| Get a snapshot of the current equalizer coefficients.
void | v22bis_equalizer_coefficient_reset (v22bis_state_t *s)
int | v22bis_rx (v22bis_state_t *s, const int16_t amp[], int len)
int | v22bis_rx_fillin (v22bis_state_t *s, int len)
int | v22bis_rx_restart (v22bis_state_t *s)
| Reinitialise an existing V.22bis modem receive context.
void | v22bis_rx_set_qam_report_handler (v22bis_state_t *s, qam_report_handler_t handler, void *user_data)

## Macro Definition Documentation

## ◆ EQUALIZER_DELTA

#define EQUALIZER_DELTA 0.25f

The adaption rate coefficient for the equalizer

## ◆ PULSESHAPER_COEFF_SETS

#define PULSESHAPER_COEFF_SETS 12

The number of phase shifted coefficient set for the pulse shaping/bandpass filter

## Function Documentation

## ◆ v22bis_rx_carrier_frequency()

float v22bis_rx_carrier_frequency | ( | v22bis_state_t * | s | ) |

Get the current received carrier frequency.

Parameters

  s | The modem context.

Returns
  The frequency, in Hertz.

References v22bis_state_s::carrier_phase_rate, and dds_frequencyf().

## ◆ v22bis_rx_equalizer_state()

int v22bis_rx_equalizer_state | ( | v22bis_state_t * | s,
|  | complexf_t ** | coeffs
| ) |  |

Get a snapshot of the current equalizer coefficients.

Get a snapshot of the current equalizer coefficients.

Parameters

  coeffs | The vector of complex coefficients.

Returns
  The number of coefficients in the vector.

References v22bis_state_s::eq_coeff.

## ◆ v22bis_rx_restart()

int v22bis_rx_restart | ( | v22bis_state_t * | s | ) |

Reinitialise an existing V.22bis modem receive context.

Reinitialise an existing V.22bis modem receive context.

Parameters

  s | The modem context.

Returns
  0 for OK, -1 for bad parameter

References v22bis_state_s::agc_scaling, v22bis_state_s::baud_phase, v22bis_state_s::calling_party, v22bis_state_s::carrier_phase, v22bis_state_s::carrier_phase_rate, v22bis_state_s::carrier_track_i, v22bis_state_s::carrier_track_p, v22bis_state_s::constellation_state, dds_phase_ratef(), v22bis_state_s::gardner_integrate, v22bis_state_s::gardner_step, power_meter_init(), v22bis_state_s::rrc_filter, v22bis_state_s::rrc_filter_step, v22bis_state_s::rx_power, v22bis_state_s::scramble_reg, v22bis_state_s::scrambler_pattern_count, v22bis_state_s::signal_present, v22bis_state_s::total_baud_timing_correction, v22bis_state_s::training, v22bis_state_s::training_count, v22bis_state_s::training_error, and v22bis_rx_signal_cutoff().

## ◆ v22bis_rx_set_qam_report_handler()

void v22bis_rx_set_qam_report_handler | ( | v22bis_state_t * | s,
|  | qam_report_handler_t | handler,
|  | void * | user_data
| ) |  |

Set a handler routine to process QAM status reports

Parameters

  s | The modem context.
  handler | The handler routine.
  user_data | An opaque pointer passed to the handler routine.

References v22bis_state_s::qam_report, and v22bis_state_s::qam_user_data.

## ◆ v22bis_rx_signal_cutoff()

void v22bis_rx_signal_cutoff | ( | v22bis_state_t * | s,
|  | float | cutoff
| ) |  |

Set the power level at which the carrier detection will cut in

Parameters

  s | The modem context.
  cutoff | The signal cutoff power, in dBm0.

References v22bis_state_s::carrier_off_power, v22bis_state_s::carrier_on_power, and power_meter_level_dbm0().

Referenced by v22bis_rx_restart().

## ◆ v22bis_rx_signal_power()

float v22bis_rx_signal_power | ( | v22bis_state_t * | s | ) |

Get a current received signal power.

Parameters

  s | The modem context.

Returns
  The signal power, in dBm0.

References power_meter_current_dbm0(), and v22bis_state_s::rx_power.

## ◆ v22bis_rx_symbol_timing_correction()

float v22bis_rx_symbol_timing_correction | ( | v22bis_state_t * | s | ) |

Get the current symbol timing correction since startup.

Parameters

  s | The modem context.

Returns
  The correction.

References PULSESHAPER_COEFF_SETS, and v22bis_state_s::total_baud_timing_correction.